package controller;

/**
 * La classe EcouteurEtoile implante les méthodes correspondant
 * aux événements souris et déplacement de la souris
 * pour dessiner des segments ayant tous une extrémité en commun.
 */

import java.awt.event.MouseEvent;

import model.Dessin;
import model.Etoile;
import view.ZoneDeDessin;

public class EcouteurEtoile extends EcouteurSouris {
	private int xc, yc;
	private Etoile etoile;

	public EcouteurEtoile(Dessin dessin, ZoneDeDessin vue) {
		super(dessin, vue);
	}

	/* en tant que MouseListener */
	public void mousePressed(MouseEvent e) {
		xc = e.getX();
		yc = e.getY();
		etoile = new Etoile(xc, yc);
		modele.ajoute(etoile);
	}

	/* en tant que MouseMotionListener */
	public void mouseDragged(MouseEvent e) {
		int x, y;
		x = e.getX();
		y = e.getY();
		etoile.ajoute(x, y);
		vue.dessineTrait(xc, yc, x, y);
	}
}
