package controller;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.io.IOException;

import model.Dessin;
import technics.DessinDAOStream;
import technics.IDessinDAO;
import view.FenetreDeDessin;
import view.ZoneDeDessin;

public class MainController implements KeyListener, MouseMotionListener {
	private FenetreDeDessin fenetreDeDessin;
	private ZoneDeDessin vue;
	private EcouteurCrayon crayon;
	private EcouteurEtoile etoile;
	private EcouteurSouris courant;
	private Dessin dessin;
	private boolean dirty;
	private IDessinDAO dessinDao;

	public MainController(Dessin dessin, FenetreDeDessin window) {
		this.fenetreDeDessin = window;
		this.vue = fenetreDeDessin.getDrawPanel();
		this.dessin = dessin;
		vue.setDessin(dessin);
		crayon = new EcouteurCrayon(dessin, vue);
		etoile = new EcouteurEtoile(dessin, vue);
		courant = null;
		changerOutil(crayon);
		fenetreDeDessin.addKeyListener(this);
		vue.addMouseMotionListener(this);
	}

	public void changerOutil(EcouteurSouris outil) {
		vue.removeMouseListener(courant);
		vue.removeMouseMotionListener(courant);
		vue.addMouseListener(outil);
		vue.addMouseMotionListener(outil);
		courant = outil;
		fenetreDeDessin.getSb().afficheOutil(outil.getClass().getSimpleName());
	}

	/* en tant que KeyListener */
	public void keyPressed(KeyEvent e) {
	}

	public void keyReleased(KeyEvent e) {
	}

	public void keyTyped(KeyEvent e) {
		switch (e.getKeyChar()) {
		case 'e':
			changerOutil(etoile);
			break;
		case 'c':
			changerOutil(crayon);
			break;
		// Pour exemple : à supprimer ensuite
		case 's':
			try {
				new DessinDAOStream("c:\\dessin.des").write(dessin);
			} catch (IOException e1) {
				e1.printStackTrace();
			}
			break;
		case 'o':
			try {
				dessin = new DessinDAOStream("c:\\dessin.des").read();
				vue.setDessin(dessin);
				vue.repaint();
			} catch (IOException | ClassNotFoundException e1) {
				e1.printStackTrace();
			}
			break;
		// Fin pour exemple
		}
	}

	@Override
	public void mouseDragged(MouseEvent evt) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseMoved(MouseEvent evt) {
		fenetreDeDessin.getSb().afficheCoordonnees(evt.getX(), evt.getY());

	}
}
