package technics;

import model.Dessin;

/**
 * Interface d'accès aux données
 * 
 * @author jc
 * 
 */
public interface IDessinDAO {
	/**
	 * Ecrit les données d'un dessin
	 * 
	 * @param dessin
	 *            dessin à sérialiser
	 * @throws Exception
	 */
	public void write(Dessin dessin) throws Exception;

	/**
	 * Charge un dessin depuis la couche d'accès aux données
	 * 
	 * @return le dessin chargé
	 * @throws Exception
	 */
	public Dessin read() throws Exception;
}
