package view;

import java.awt.BorderLayout;
import java.awt.HeadlessException;

import javax.swing.ButtonGroup;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;

import model.Dessin;

/**
 * @author jcheron
 * 
 */
public class FenetreDeDessin extends JFrame {

	private StatusBar sb;
	private ZoneDeDessin drawPanel;
	private JRadioButtonMenuItem mnItemCrayon;
	private JRadioButtonMenuItem mnItemEtoile;

	public FenetreDeDessin() throws HeadlessException {
		super();
		setLayout(new BorderLayout());
		createDrawPanel();
		createStatusBar();
		createMenu();
		setSize(300, 400);
	}

	/**
	 * Création du menu
	 */
	private void createMenu() {
		JMenuBar menuBar = new JMenuBar();
		JMenu menu = new JMenu("Dessin");
		menuBar.add(menu);
		JMenuItem menuItem = addMenuItem(menu, "Ouvrir...");
		menu.addSeparator();
		menuItem = addMenuItem(menu, "Enregistrer");
		menuItem = addMenuItem(menu, "Enregistrer sous...");
		menu.addSeparator();
		menuItem = addMenuItem(menu, "Effacer");
		menu.addSeparator();
		menuItem = addMenuItem(menu, "Quitter");
		setJMenuBar(menuBar);
		menu = new JMenu("Outil");
		menuBar.add(menu);
		ButtonGroup btnGroup = new ButtonGroup();
		mnItemCrayon = new JRadioButtonMenuItem("Crayon");
		btnGroup.add(mnItemCrayon);
		menu.add(mnItemCrayon);
		mnItemEtoile = new JRadioButtonMenuItem("Etoile");
		btnGroup.add(mnItemEtoile);
		menu.add(mnItemEtoile);
		btnGroup.setSelected(mnItemCrayon.getModel(), true);
		menu = new JMenu("?");
		menuBar.add(menu);
		menuItem = addMenuItem(menu, "A propos de...");
	}

	private JMenuItem addMenuItem(JMenu menu, String caption) {
		return menu.add(new JMenuItem(caption));
	}

	/**
	 * Création de la barre d'état
	 */
	private void createStatusBar() {
		sb = new StatusBar();
		add(sb, BorderLayout.SOUTH);
	}

	/**
	 * Création de la zone de dessin ( classe Héritant de Jpanel)
	 */
	private void createDrawPanel() {
		drawPanel = new ZoneDeDessin();
		add(drawPanel, BorderLayout.CENTER);
	}

	public void setDessin(Dessin dessin) {
		drawPanel.setDessin(dessin);
	}

	public StatusBar getSb() {
		return sb;
	}

	public ZoneDeDessin getDrawPanel() {
		return drawPanel;
	}

	public JRadioButtonMenuItem getMnItemCrayon() {
		return mnItemCrayon;
	}

	public JRadioButtonMenuItem getMnItemEtoile() {
		return mnItemEtoile;
	}
}
