package view;

import java.awt.Graphics;
import java.awt.Point;

import javax.swing.JPanel;

import model.Dessin;
import model.Etoile;
import model.Figure;
import model.Trace;

/**
 * Correspond à une zone de dessin (drawPanel)
 * 
 * @author heronj
 * 
 */
public class ZoneDeDessin extends JPanel {
	private Dessin dessin;

	public void setDessin(Dessin dessin) {
		this.dessin = dessin;
	}

	public void dessineTrait(int x1, int y1, int x2, int y2) {
		Graphics g = getGraphics();
		g.drawLine(x1, y1, x2, y2);
	}

	public void dessineFigure(Figure figure, Graphics g) {
	}

	public void dessineFigure(Trace trace, Graphics g) {
		Point pt = trace.element(0);
		int xd, yd, x, y;
		xd = (int) (pt.getX());
		yd = (int) (pt.getY());
		for (int numPt = 1; numPt < trace.nbPoints(); numPt++) {
			pt = trace.element(numPt);
			x = (int) (pt.getX());
			y = (int) (pt.getY());
			g.drawLine(xd, yd, x, y);
			xd = x;
			yd = y;
		}
	}

	public void dessineFigure(Etoile etoile, Graphics g) {
		Point pt = etoile.centre();
		int xc, yc, x, y;
		xc = (int) (pt.getX());
		yc = (int) (pt.getY());
		for (int numPt = 0; numPt < etoile.nbPoints(); numPt++) {
			pt = etoile.element(numPt);
			x = (int) (pt.getX());
			y = (int) (pt.getY());
			g.drawLine(xc, yc, x, y);
		}
	}

	public void paint(Graphics g) {
		Figure f;
		for (int numFig = 0; numFig < dessin.nbFigures(); numFig++) {
			f = dessin.element(numFig);
			if (f instanceof Trace)
				dessineFigure((Trace) f, g);
			if (f instanceof Etoile)
				dessineFigure((Etoile) f, g);
		}
	}

	public void clear() {
		dessin.effacer();
		repaint();

	}

}
